Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/tesselationhelpers.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -977,14 +946,14 @@
         const int size = PairTrianglenodes.endpoints.size();
         if (size == 4) {
-          Log() << Verbose(0) << " Current pair of triangles: " << **Walker << "," << **PairWalker << " with " << size << " distinct endpoints:" << PairTrianglenodes << endl;
+          DoLog(0) && (Log() << Verbose(0) << " Current pair of triangles: " << **Walker << "," << **PairWalker << " with " << size << " distinct endpoints:" << PairTrianglenodes << endl);
           // now check
           if (PairTrianglenodes.ContainsPresentTupel(P)) {
             counter++;
-            Log() << Verbose(0) << "  ACCEPT: Matches with " << *P << endl;
+            DoLog(0) && (Log() << Verbose(0) << "  ACCEPT: Matches with " << *P << endl);
           } else {
-            Log() << Verbose(0) << "  REJECT: No match with " << *P << endl;
+            DoLog(0) && (Log() << Verbose(0) << "  REJECT: No match with " << *P << endl);
           }
         } else {
-          Log() << Verbose(0) << "  REJECT: Less than four endpoints." << endl;
+          DoLog(0) && (Log() << Verbose(0) << "  REJECT: Less than four endpoints." << endl);
         }
       }
@@ -1007,5 +976,5 @@
     if (P2->ContainsBoundaryPoint((*Runner))) {
       counter++;
-      Log() << Verbose(1) << *(*Runner) << " of second polygon is found in the first one." << endl;
+      DoLog(1) && (Log() << Verbose(1) << *(*Runner) << " of second polygon is found in the first one." << endl);
       return true;
     }
@@ -1025,5 +994,5 @@
     Tester = P1->endpoints.insert((*Runner));
     if (Tester.second)
-      Log() << Verbose(0) << "Inserting endpoint " << *(*Runner) << " into first polygon." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Inserting endpoint " << *(*Runner) << " into first polygon." << endl);
   }
   P2->endpoints.clear();
Index: src/test/ActOnAlltest.hpp
===================================================================
--- src/test/ActOnAlltest.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/test/ActOnAlltest.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -27,4 +27,5 @@
 
   template <typename klasse, typename res, typename T> void ActOnAll( res (klasse::*f)(T), T t );
+  template <typename klasse, typename res, typename T> void ActOnAll( res (klasse::*f)(T&), T &t );
   template <typename klasse, typename res, typename T, typename U> void ActOnAll( res (klasse::*f)(T, U), T t, U u );
   template <typename klasse, typename res, typename T, typename U, typename V> void ActOnAll( res (klasse::*f)(T, U, V), T t, U u, V v);
@@ -76,4 +77,10 @@
 };
 
+template <typename klasse, typename res, typename T> void VectorList::ActOnAll( res (klasse::*f)(T&), T &t )
+{
+  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++)
+    ((*Runner)->*f)(t);
+};
+
 template <typename klasse, typename res, typename T, typename U> void VectorList::ActOnAll( res (klasse::*f)(T, U), T t, U u )
 {
Index: src/triangleintersectionlist.cpp
===================================================================
--- src/triangleintersectionlist.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/triangleintersectionlist.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,172 @@
+/*
+ * triangleintersectionlist.cpp
+ *
+ * This files encapsulates the TriangleIntersectionList class where all matters related to points in space being how close to
+ * a tesselated surface are answered, i.e. distance, is inside, ...
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: heber
+ */
+
+#include "triangleintersectionlist.hpp"
+
+#include "info.hpp"
+#include "tesselation.hpp"
+#include "vector.hpp"
+
+/** Constructor for class TriangleIntersectionList.
+ *
+ */
+TriangleIntersectionList::TriangleIntersectionList(const Vector *x, const Tesselation *surface, const LinkedCell* LC) :
+  Point(x),
+  Tess(surface),
+  Vicinity(LC)
+{
+  Info FunctionInfo(__func__);
+  GatherIntersectionsWithTriangles();
+};
+
+/** Destructor for class TriangleIntersectionList.
+ * Free's all allocated intersection vectors
+ */
+TriangleIntersectionList::~TriangleIntersectionList()
+{
+  Info FunctionInfo(__func__);
+  for (TriangleVectorMap::iterator Runner = IntersectionList.begin(); Runner != IntersectionList.end(); Runner++)
+    delete((*Runner).second);
+};
+
+/** Returns the smallest distance between TriangleIntersectionList::Point and the surface given by
+ * TriangleIntersectionList::Tess.
+ * \return distance >=0, -1 if no specific distance could be found
+ */
+double TriangleIntersectionList::GetSmallestDistance() const
+{
+  Info FunctionInfo(__func__);
+  FillDistanceList();
+  if (!DistanceList.empty())
+    return DistanceList.begin()->first;
+  else
+    // return reference, if none can be found
+    return -1.;
+};
+
+/** Returns the vector of closest intersection between TriangleIntersectionList::Point and the surface
+ * TriangleIntersectionList::Tess.
+ * \return Intersection vector or TriangleIntersectionList::Point if none could be found
+ */
+Vector TriangleIntersectionList::GetClosestIntersection() const
+{
+  Info FunctionInfo(__func__);
+  TriangleVectorMap::const_iterator runner;
+  runner = GetIteratortoSmallestDistance();
+  if (runner != IntersectionList.end()) {
+    return *((*runner).second);
+  }
+  // return reference, if none can be found
+  return *Point;
+};
+
+/** Returns the triangle closest to TriangleIntersectionList::Point and the surface
+ * TriangleIntersectionList::Tess.
+ * \return pointer to triangle or NULL if none could be found
+ */
+BoundaryTriangleSet * TriangleIntersectionList::GetClosestTriangle() const
+{
+  Info FunctionInfo(__func__);
+  TriangleVectorMap::const_iterator runner;
+  runner = GetIteratortoSmallestDistance();
+  if (runner != IntersectionList.end()) {
+    return ((*runner).first);
+  }
+  // return reference, if none can be found
+  return NULL;
+};
+
+/** Checks whether reference TriangleIntersectionList::Point of this class is inside or outside.
+ * \return true - TriangleIntersectionList::Point is inside, false - is outside
+ */
+bool TriangleIntersectionList::IsInside() const
+{
+  Info FunctionInfo(__func__);
+  TriangleVectorMap::const_iterator runner;
+  runner = GetIteratortoSmallestDistance();
+  if (runner != IntersectionList.end()) {
+    // if we have found one, check Scalarproduct between the vector
+    Vector TestVector = (*Point) - (*(*runner).second);
+    if (fabs(TestVector.NormSquared()) < MYEPSILON) //
+      return true;
+    const double sign = (*runner).first->NormalVector.ScalarProduct(TestVector);
+    if (sign < 0) {
+      return true;
+    } else {
+      return false;
+    }
+  }
+  // so far away from surface that there are no triangles in list
+  return false;
+};
+
+/** Puts all triangles in vicinity (by \a *LC) into a hash map with Intersection vectors.
+ * Private function for constructor of TriangleIntersectionList.
+ */
+void TriangleIntersectionList::GatherIntersectionsWithTriangles()
+{
+  Info FunctionInfo(__func__);
+
+  // get closest points
+  DistanceToPointMap * points = Tess->FindClosestBoundaryPointsToVector(Point,Vicinity);
+  if (points == NULL) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "There is no nearest point: too far away from the surface." << endl);
+    return;
+  }
+
+  // gather all triangles in *LC-neighbourhood
+  TriangleSet triangles;
+  for (DistanceToPointMap::iterator Runner = points->begin(); Runner != points->end(); Runner++)
+    for (LineMap::iterator LineRunner = Runner->second->lines.begin(); LineRunner != Runner->second->lines.end(); LineRunner++)
+      for (TriangleMap::iterator TriangleRunner = LineRunner->second->triangles.begin(); TriangleRunner != LineRunner->second->triangles.end(); TriangleRunner++)
+        triangles.insert(TriangleRunner->second);
+
+  Vector *Intersection = NULL;
+  for (TriangleSet::const_iterator TriangleRunner = triangles.begin(); TriangleRunner != triangles.end(); TriangleRunner++) {
+    // get intersection with triangle plane
+    Intersection = new Vector;
+    (*TriangleRunner)->GetClosestPointInsideTriangle(Point, Intersection);
+    //Log() << Verbose(1) << "Intersection between " << *Point << " and " << **TriangleRunner << " is at " << *Intersection << "." << endl;
+    IntersectionList.insert( pair<BoundaryTriangleSet *, Vector * > (*TriangleRunner, Intersection) );
+  }
+};
+
+/** Fills the private distance list
+ */
+void TriangleIntersectionList::FillDistanceList() const
+{
+  Info FunctionInfo(__func__);
+  if (DistanceList.empty())
+    for (TriangleVectorMap::const_iterator runner = IntersectionList.begin(); runner != IntersectionList.end(); runner++)
+      DistanceList.insert( pair<double, BoundaryTriangleSet *> (Point->distance(*(*runner).second), (*runner).first) );
+
+  //for (DistanceTriangleMap::const_iterator runner = DistanceList.begin(); runner != DistanceList.end(); runner++)
+  //  Log() << Verbose(1) << (*runner).first << " away from " << *(*runner).second << endl;
+};
+
+
+/** Returns the iterator in VectorTriangleMap to the smallest distance.
+ * This is a private helper function as the iterator is then evaluated in some other functions.
+ * \return iterator or TriangleIntersectionList::IntersectionList.end() if none could be found
+ */
+TriangleVectorMap::const_iterator TriangleIntersectionList::GetIteratortoSmallestDistance() const
+{
+  Info FunctionInfo(__func__);
+  FillDistanceList();
+
+  // do we have any intersections?
+  TriangleVectorMap::const_iterator runner;
+  if (!DistanceList.empty()) {
+    // get closest triangle
+    runner = IntersectionList.find(DistanceList.begin()->second);
+  }
+  return runner;
+};
+
Index: src/triangleintersectionlist.hpp
===================================================================
--- src/triangleintersectionlist.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/triangleintersectionlist.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,61 @@
+/*
+ * TriangleIntersectionList.hpp
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: heber
+ */
+
+#ifndef TRIANGLEINTERSECTIONLIST_HPP_
+#define TRIANGLEINTERSECTIONLIST_HPP_
+
+using namespace std;
+
+/*********************************************** includes ***********************************/
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <map>
+
+/****************************************** forward declarations *****************************/
+
+class BoundaryTriangleSet;
+class LinkedCell;
+class Tesselation;
+class Vector;
+
+/********************************************** definitions *********************************/
+
+#define TriangleVectorMap map < class BoundaryTriangleSet *, Vector *>
+#define DistanceTriangleMap map < double, class BoundaryTriangleSet *>
+
+// ======================================================== class TriangleIntersectionList =======================================
+
+/** Stores all intersection vectors to a list of triangles.
+ */
+class TriangleIntersectionList
+{
+public:
+  TriangleIntersectionList(const Vector *x, const Tesselation *surface, const LinkedCell* LC);
+  ~TriangleIntersectionList();
+
+  double GetSmallestDistance() const;
+  Vector GetClosestIntersection() const;
+  BoundaryTriangleSet * GetClosestTriangle() const;
+  bool IsInside() const;
+
+private:
+  void GatherIntersectionsWithTriangles();
+  TriangleVectorMap::const_iterator GetIteratortoSmallestDistance() const;
+  void FillDistanceList() const;
+
+  const Vector *Point;
+  const Tesselation *Tess;
+  const LinkedCell *Vicinity;
+  TriangleVectorMap IntersectionList;
+  mutable DistanceTriangleMap DistanceList;
+};
+
+#endif /* TRIANGLEINTERSECTIONLIST_HPP_ */
Index: src/types.hpp
===================================================================
--- src/types.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/types.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,21 @@
+/*
+ * types.hpp
+ *
+ *  Created on: Mar 12, 2010
+ *      Author: crueger
+ */
+
+#ifndef TYPES_HPP_
+#define TYPES_HPP_
+
+
+/**
+ *  This file defines some globally used types for later use
+ */
+
+
+typedef unsigned int atomId_t;        //!< The type of atomIds
+typedef unsigned int moleculeId_t;    //!< The type of moleculeIds
+typedef unsigned int atomicNumber_t;  //!< The type of atomicNumbers
+
+#endif /* TYPES_HPP_ */
Index: src/unittests/ActOnAllUnitTest.cpp
===================================================================
--- src/unittests/ActOnAllUnitTest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/ActOnAllUnitTest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -44,4 +44,7 @@
 {
   VL.EmptyList();
+  // Ref was copy constructed, hence has to be cleaned, too!
+  Ref.EmptyList();
+  MemoryUsageObserver::purgeInstance();
 };
 
@@ -53,7 +56,7 @@
 
   // adding, subtracting
-  VL.ActOnAll( &Vector::AddVector, &test );
+  VL.ActOnAll( &Vector::AddVector, test );
   CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
-  VL.ActOnAll( &Vector::SubtractVector, &test );
+  VL.ActOnAll( &Vector::SubtractVector, test );
   CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
 };
@@ -67,15 +70,8 @@
 
   // scaling by value
-  VL.ActOnAll( (void (Vector::*)(const double)) &Vector::Scale, 2. );
+  VL.ActOnAll( (void (Vector::*)(const double)) &Vector::Scale, factor );
   CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
 
-  VL.ActOnAll( (void (Vector::*)(const double)) &Vector::Scale, 0.5 );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
-
-  // scaling by ref
-  VL.ActOnAll( (void (Vector::*)(const double * const)) &Vector::Scale, (const double * const)&factor );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
-
-  VL.ActOnAll( (void (Vector::*)(const double * const)) &Vector::Scale, (const double * const)&inverse );
+  VL.ActOnAll( (void (Vector::*)(const double)) &Vector::Scale, inverse );
   CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
 
@@ -87,10 +83,23 @@
     inverses[i] = 1./factors[i];
   }
-  VL.ActOnAll( (void (Vector::*)(const double ** const)) &Vector::Scale, (const double ** const)&factors );
+  VL.ActOnAll<Vector,void,const double*>(&Vector::ScaleAll, factors );
   CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
 
-  VL.ActOnAll( (void (Vector::*)(const double ** const)) &Vector::Scale, (const double ** const)&inverses );
+  VL.ActOnAll<Vector,void,const double*>(&Vector::ScaleAll, inverses );
   CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
+  Free(factors);
+  Free(inverses);
 };
+
+#if 0
+
+// Unitttest deactivated for now...
+// Reasons:
+//    Vector::MakeNormalVector has been removed and is now part of Plane class
+//    VectorList::ActOnAll is in the test directory and seems to be used only for unittests
+//    MakeNormal never depended on the input Vector except in the case of linear dependence (i.e. failure)
+//
+// TODO: Rethink what exactely is being tested at this point and introduce a new unittest for the
+//       tested behaviour. Most likely this should result in a thourough unittest of the plane class
 
 /** UnitTest for VectorList::ActOnAll() and Vector::MakeNormalVector()
@@ -108,6 +117,8 @@
   // check that x and y components are zero
   for (ListOfVectors::iterator Runner = VL.Vectors.begin(); Runner != VL.Vectors.end(); Runner++) {
-    CPPUNIT_ASSERT_EQUAL( (*Runner)->x[0] , 0. );
-    CPPUNIT_ASSERT_EQUAL( (*Runner)->x[1] , 0. );
+    CPPUNIT_ASSERT_EQUAL( (*Runner)->at(0) , 0. );
+    CPPUNIT_ASSERT_EQUAL( (*Runner)->at(1) , 0. );
   }
 };
+
+#endif
Index: src/unittests/ActOnAllUnitTest.hpp
===================================================================
--- src/unittests/ActOnAllUnitTest.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/ActOnAllUnitTest.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -20,5 +20,8 @@
     CPPUNIT_TEST ( AddSubtractTest );
     CPPUNIT_TEST ( ScaleTest );
+#if 0
+    // test deactivated. See .cpp for reasons and workarounds
     CPPUNIT_TEST ( NormalizeTest );
+#endif
     CPPUNIT_TEST_SUITE_END();
 
Index: src/unittests/ActionSequenceTest.cpp
===================================================================
--- src/unittests/ActionSequenceTest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/ActionSequenceTest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -13,4 +13,7 @@
 #include "Actions/Action.hpp"
 #include "Actions/ActionSequence.hpp"
+#include "Actions/MakroAction.hpp"
+#include "Actions/ActionHistory.hpp"
+#include "Actions/ActionRegistry.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -22,9 +25,4 @@
 // Registers the fixture into the 'registry'
 CPPUNIT_TEST_SUITE_REGISTRATION( ActionSequenceTest );
-
-void setUp();
-void tearDown();
-
-void canUndoTest();
 
 /* some neccessary stubs for tests */
@@ -35,7 +33,17 @@
   virtual ~canUndoActionStub(){}
 
-  virtual void call(){}
-  virtual void undo(){}
+  virtual Action::state_ptr performCall(){
+    return Action::success;
+  }
+  virtual Action::state_ptr performUndo(Action::state_ptr){
+    return Action::success;
+  }
+  virtual Action::state_ptr performRedo(Action::state_ptr){
+    return Action::success;
+  }
   virtual bool canUndo(){
+    return true;
+  }
+  virtual bool shouldUndo(){
     return true;
   }
@@ -48,8 +56,18 @@
   virtual ~cannotUndoActionStub(){}
 
-  virtual void call(){}
-  virtual void undo(){}
+  virtual Action::state_ptr performCall(){
+    return Action::success;
+  }
+  virtual Action::state_ptr performUndo(Action::state_ptr){
+    return Action::success;
+  }
+  virtual Action::state_ptr performRedo(Action::state_ptr){
+    return Action::success;
+  }
   virtual bool canUndo(){
     return false;
+  }
+  virtual bool shouldUndo(){
+   return true;
   }
 };
@@ -64,11 +82,20 @@
   virtual ~wasCalledActionStub(){}
 
-  virtual void call(){
+  virtual Action::state_ptr performCall(){
     called = true;
-  }
-  virtual void undo(){
+    return Action::success;
+  }
+  virtual Action::state_ptr performUndo(Action::state_ptr){
     called = false;
+    return Action::success;
+  }
+  virtual Action::state_ptr performRedo(Action::state_ptr){
+    called = true;
+    return Action::success;
   }
   virtual bool canUndo(){
+    return true;
+  }
+  virtual bool shouldUndo(){
     return true;
   }
@@ -81,4 +108,5 @@
 
 void ActionSequenceTest::setUp(){
+  ActionHistory::init();
   // create some necessary stubs used in this test
   positive1 = new canUndoActionStub();
@@ -105,4 +133,6 @@
   delete shouldNotCall2;
 
+  ActionHistory::purgeInstance();
+  ActionRegistry::purgeInstance();
 }
 
@@ -175,26 +205,27 @@
   CPPUNIT_ASSERT_EQUAL(false,shouldNotCall2->wasCalled());
 
+  delete sequence;
 }
 
 void ActionSequenceTest::doesUndoTest(){
   ActionSequence *sequence = new ActionSequence();
-  sequence->addAction(shouldNotCall1);
-  sequence->addAction(shouldNotCall2);
-  sequence->addAction(shouldCall1);
-  sequence->addAction(shouldCall2);
-
-  sequence->callAll();
-
-  sequence->removeLastAction();
-  sequence->removeLastAction();
-
-  sequence->undoAll();
-
-  CPPUNIT_ASSERT_EQUAL(true,shouldCall1->wasCalled());
-  CPPUNIT_ASSERT_EQUAL(true,shouldCall2->wasCalled());
-  CPPUNIT_ASSERT_EQUAL(false,shouldNotCall1->wasCalled());
-  CPPUNIT_ASSERT_EQUAL(false,shouldNotCall2->wasCalled());
-
-}
-
-
+  wasCalledActionStub *wasCalled1 = new wasCalledActionStub();
+  wasCalledActionStub *wasCalled2 = new wasCalledActionStub();
+  sequence->addAction(wasCalled1);
+  sequence->addAction(wasCalled2);
+
+  MakroAction act("Test MakroAction",sequence,false);
+
+  act.call();
+
+  CPPUNIT_ASSERT_EQUAL(true,wasCalled1->wasCalled());
+  CPPUNIT_ASSERT_EQUAL(true,wasCalled1->wasCalled());
+
+  ActionHistory::getInstance().undoLast();
+
+  CPPUNIT_ASSERT_EQUAL(false,wasCalled1->wasCalled());
+  CPPUNIT_ASSERT_EQUAL(false,wasCalled1->wasCalled());
+
+}
+
+
Index: src/unittests/AnalysisCorrelationToPointUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -17,4 +17,5 @@
 #include "AnalysisCorrelationToPointUnitTest.hpp"
 
+#include "World.hpp"
 #include "atom.hpp"
 #include "boundary.hpp"
@@ -24,4 +25,5 @@
 #include "periodentafel.hpp"
 #include "tesselation.hpp"
+#include "World.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -55,24 +57,24 @@
 
   // construct periodentafel
-  tafel = new periodentafel;
+  tafel = World::getInstance().getPeriode();
   tafel->AddElement(hydrogen);
 
   // construct molecule (tetraeder of hydrogens)
-  TestMolecule = new molecule(tafel);
-  Walker = new atom();
+  TestMolecule = World::getInstance().createMolecule();
+  Walker = World::getInstance().createAtom();
   Walker->type = hydrogen;
-  Walker->node->Init(1., 0., 1. );
+  *Walker->node = Vector(1., 0., 1. );
   TestMolecule->AddAtom(Walker);
-  Walker = new atom();
+  Walker = World::getInstance().createAtom();
   Walker->type = hydrogen;
-  Walker->node->Init(0., 1., 1. );
+  *Walker->node = Vector(0., 1., 1. );
   TestMolecule->AddAtom(Walker);
-  Walker = new atom();
+  Walker = World::getInstance().createAtom();
   Walker->type = hydrogen;
-  Walker->node->Init(1., 1., 0. );
+  *Walker->node = Vector(1., 1., 0. );
   TestMolecule->AddAtom(Walker);
-  Walker = new atom();
+  Walker = World::getInstance().createAtom();
   Walker->type = hydrogen;
-  Walker->node->Init(0., 0., 0. );
+  *Walker->node = Vector(0., 0., 0. );
   TestMolecule->AddAtom(Walker);
 
@@ -80,7 +82,7 @@
   CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 4 );
 
-  TestList = new MoleculeListClass;
+  TestList = World::getInstance().getMolecules();
+  TestList->insert(TestMolecule);
   TestMolecule->ActiveFlag = true;
-  TestList->insert(TestMolecule);
 
   // init point
@@ -101,10 +103,8 @@
     delete(binmap);
 
-  // remove
-  delete(TestList);
-  // note that all the atoms are cleaned by TestMolecule
   delete(point);
-  delete(tafel);
-  // note that element is cleaned by periodentafel
+  World::purgeInstance();
+  MemoryUsageObserver::purgeInstance();
+  logger::purgeInstance();
 };
 
@@ -122,6 +122,6 @@
   // put pair correlation into bins and check with no range
   binmap = BinData( pointmap, 0.5, 0., 0. );
-  CPPUNIT_ASSERT_EQUAL( (size_t)2, binmap->size() );
-  //OutputCorrelation ( binmap );
+  OutputCorrelation ( (ofstream *)&cout, binmap );
+  CPPUNIT_ASSERT_EQUAL( (size_t)3, binmap->size() );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 1., tester->first );
@@ -135,6 +135,6 @@
   // ... and check with [0., 2.] range
   binmap = BinData( pointmap, 0.5, 0., 2. );
+  OutputCorrelation ( (ofstream *)&cout, binmap );
   CPPUNIT_ASSERT_EQUAL( (size_t)5, binmap->size() );
-  //OutputCorrelation ( binmap );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 0., tester->first );
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -17,4 +17,5 @@
 #include "AnalysisCorrelationToSurfaceUnitTest.hpp"
 
+#include "World.hpp"
 #include "atom.hpp"
 #include "boundary.hpp"
@@ -24,4 +25,7 @@
 #include "periodentafel.hpp"
 #include "tesselation.hpp"
+#include "World.hpp"
+
+#include "Helpers/Assert.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -36,9 +40,11 @@
 void AnalysisCorrelationToSurfaceUnitTest::setUp()
 {
+  //ASSERT_DO(Assert::Throw);
+
   atom *Walker = NULL;
 
   // init private all pointers to zero
   TestList = NULL;
-  TestMolecule = NULL;
+  TestSurfaceMolecule = NULL;
   hydrogen = NULL;
   tafel = NULL;
@@ -59,60 +65,61 @@
 
   // construct periodentafel
-  tafel = new periodentafel;
+  tafel = World::getInstance().getPeriode();
   tafel->AddElement(hydrogen);
   tafel->AddElement(carbon);
 
   // construct molecule (tetraeder of hydrogens) base
-  TestMolecule = new molecule(tafel);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(1., 0., 1. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(0., 1., 1. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(1., 1., 0. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = hydrogen;
-  Walker->node->Init(0., 0., 0. );
-  TestMolecule->AddAtom(Walker);
+  TestSurfaceMolecule = World::getInstance().createMolecule();
+  Walker = World::getInstance().createAtom();
+  Walker->type = hydrogen;
+  *Walker->node = Vector(1., 0., 1. );
+
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  Walker->type = hydrogen;
+  *Walker->node = Vector(0., 1., 1. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  Walker->type = hydrogen;
+  *Walker->node = Vector(1., 1., 0. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  Walker->type = hydrogen;
+  *Walker->node = Vector(0., 0., 0. );
+  TestSurfaceMolecule->AddAtom(Walker);
 
   // check that TestMolecule was correctly constructed
-  CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 4 );
-
-  TestList = new MoleculeListClass;
-  TestMolecule->ActiveFlag = true;
-  TestList->insert(TestMolecule);
+  CPPUNIT_ASSERT_EQUAL( TestSurfaceMolecule->AtomCount, 4 );
+
+  TestList = World::getInstance().getMolecules();
+  TestSurfaceMolecule->ActiveFlag = true;
+  TestList->insert(TestSurfaceMolecule);
 
   // init tesselation and linked cell
   Surface = new Tesselation;
-  FindNonConvexBorder(TestMolecule, Surface, (const LinkedCell *&)LC, 2.5, NULL);
-  LC = new LinkedCell(TestMolecule, 5.);
-  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->PointsOnBoundary.size() );
-  CPPUNIT_ASSERT_EQUAL( (size_t)6, Surface->LinesOnBoundary.size() );
-  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->TrianglesOnBoundary.size() );
+  LC = new LinkedCell(TestSurfaceMolecule, 5.);
+  FindNonConvexBorder(TestSurfaceMolecule, Surface, (const LinkedCell *&)LC, 2.5, NULL);
 
   // add outer atoms
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(4., 0., 4. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(0., 4., 4. );
-  TestMolecule->AddAtom(Walker);
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(4., 4., 0. );
-  TestMolecule->AddAtom(Walker);
+  TestSurfaceMolecule = World::getInstance().createMolecule();
+  Walker = World::getInstance().createAtom();
+  Walker->type = carbon;
+  *Walker->node = Vector(4., 0., 4. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  Walker->type = carbon;
+  *Walker->node = Vector(0., 4., 4. );
+  TestSurfaceMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  Walker->type = carbon;
+  *Walker->node = Vector(4., 4., 0. );
+  TestSurfaceMolecule->AddAtom(Walker);
   // add inner atoms
-  Walker = new atom();
-  Walker->type = carbon;
-  Walker->node->Init(0.5, 0.5, 0.5 );
-  TestMolecule->AddAtom(Walker);
+  Walker = World::getInstance().createAtom();
+  Walker->type = carbon;
+  *Walker->node = Vector(0.5, 0.5, 0.5 );
+  TestSurfaceMolecule->AddAtom(Walker);
+  TestSurfaceMolecule->ActiveFlag = true;
+  TestList->insert(TestSurfaceMolecule);
 
   // init maps
@@ -130,13 +137,23 @@
     delete(binmap);
 
-  // remove
-  delete(TestList);
   delete(Surface);
   // note that all the atoms are cleaned by TestMolecule
   delete(LC);
-  delete(tafel);
-  // note that element is cleaned by periodentafel
-};
-
+  World::purgeInstance();
+  MemoryUsageObserver::purgeInstance();
+  logger::purgeInstance();
+};
+
+
+/** Checks whether setup() does the right thing.
+ */
+void AnalysisCorrelationToSurfaceUnitTest::SurfaceTest()
+{
+  CPPUNIT_ASSERT_EQUAL( 4, TestSurfaceMolecule->AtomCount );
+  CPPUNIT_ASSERT_EQUAL( (size_t)2, TestList->ListOfMolecules.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->PointsOnBoundary.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)6, Surface->LinesOnBoundary.size() );
+  CPPUNIT_ASSERT_EQUAL( (size_t)4, Surface->TrianglesOnBoundary.size() );
+};
 
 void AnalysisCorrelationToSurfaceUnitTest::CorrelationToSurfaceTest()
@@ -144,4 +161,5 @@
   // do the pair correlation
   surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   CPPUNIT_ASSERT( surfacemap != NULL );
   CPPUNIT_ASSERT_EQUAL( (size_t)4, surfacemap->size() );
@@ -153,7 +171,8 @@
   surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
   // put pair correlation into bins and check with no range
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   binmap = BinData( surfacemap, 0.5, 0., 0. );
   CPPUNIT_ASSERT_EQUAL( (size_t)1, binmap->size() );
-  //OutputCorrelation ( binmap );
+  OutputCorrelation ( (ofstream *)&cout, binmap );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 0., tester->first );
@@ -166,8 +185,9 @@
   BinPairMap::iterator tester;
   surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // ... and check with [0., 2.] range
   binmap = BinData( surfacemap, 0.5, 0., 2. );
   CPPUNIT_ASSERT_EQUAL( (size_t)5, binmap->size() );
-  //OutputCorrelation ( binmap );
+//  OutputCorrelation ( (ofstream *)&cout, binmap );
   tester = binmap->begin();
   CPPUNIT_ASSERT_EQUAL( 0., tester->first );
@@ -183,14 +203,15 @@
   BinPairMap::iterator tester;
   surfacemap = CorrelationToSurface( TestList, carbon, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // put pair correlation into bins and check with no range
   binmap = BinData( surfacemap, 0.5, 0., 0. );
-  CPPUNIT_ASSERT_EQUAL( (size_t)2, binmap->size() );
-  OutputCorrelation ( (ofstream *)&cout, binmap );
+  //OutputCorrelation ( (ofstream *)&cout, binmap );
+  CPPUNIT_ASSERT_EQUAL( (size_t)9, binmap->size() );
   // inside point is first and must have negative value
-  tester = binmap->lower_bound(2.95); // start depends on the min value and
+  tester = binmap->lower_bound(4.25-0.5); // start depends on the min value and
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 3, tester->second );
   // inner point
-  tester = binmap->lower_bound(-0.5);
+  tester = binmap->lower_bound(0.);
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 1, tester->second );
@@ -201,16 +222,16 @@
   BinPairMap::iterator tester;
   surfacemap = CorrelationToSurface( TestList, carbon, Surface, LC );
+//  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // ... and check with [0., 2.] range
   binmap = BinData( surfacemap, 0.5, -2., 4. );
+  //OutputCorrelation ( (ofstream *)&cout, binmap );
   CPPUNIT_ASSERT_EQUAL( (size_t)13, binmap->size() );
-  OutputCorrelation ( (ofstream *)&cout, binmap );
   // three outside points
-  tester = binmap->lower_bound(3.);
+  tester = binmap->lower_bound(4.25-0.5);
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 3, tester->second );
   // inner point
-  tester = binmap->lower_bound(-0.5);
+  tester = binmap->lower_bound(0.);
   CPPUNIT_ASSERT( tester != binmap->end() );
   CPPUNIT_ASSERT_EQUAL( 1, tester->second );
-
-};
+};
